package com.mudchobo.mudchoboplayer.services
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	
	public class OverviewService extends EventDispatcher
	{
		private var _soundInfo:Object = new Object();
		
		[Bindable(event="soundInfoChanged")]
		public function get soundInfo():Object 
		{
			return _soundInfo;
		}
		
		public function frameOverview(sound:Sound, channel:SoundChannel):void
		{
			if (channel == null || sound == null)
			{
				return;
			}
			
			var maxTime:int = 
    			Math.ceil(sound.length / (sound.bytesLoaded / sound.bytesTotal)) / 1000;
			var playTime:uint = channel.position / 1000; 
			
			_soundInfo.playTime = playTime;
			_soundInfo.maxTime = maxTime;
			_soundInfo.songName = sound.id3.songName;
			_soundInfo.artist = sound.id3.artist;
			_soundInfo.fileName = sound.url;
			
			dispatchEvent(new Event("soundInfoChanged"));	
		}
	}
}
