package com.mudchobo.mudchoboplayer.services
{
	import com.mudchobo.mudchoboplayer.data.ApplicationData;
	import com.mudchobo.mudchoboplayer.events.PlayEvent;
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.media.Sound;
	import flash.net.URLRequest;
	
	import mx.collections.ArrayCollection;

	public class PlayService extends EventDispatcher
	{
		private var dispatcher:IEventDispatcher;
		private var _sound:Sound;
		
		public function PlayService(dispatcher:IEventDispatcher)
		{
			this.dispatcher = dispatcher;
		}
		
		[Bindable(event="soundChanged")]
		public function get sound():Sound 
		{
			return _sound;
		}
					
		public function playPlay(id:Number):void
		{
			var appData:ApplicationData = ApplicationData.getInstance();
			var soundList:ArrayCollection = appData.soundList;
			var currentSound:Number = appData.currentSound;
			
			var tempId:Number = id;
			
			// 다음곡이 없는 경우 처음으로
			if (id > soundList.length)
			{
				tempId = 1;
			}
			
			// 이전곡이 없는 경우
			if (id < 1)
			{
				tempId = appData.soundList.length;
			}
			
			for (var i:Number = 0; i < appData.soundList.length; i++)
			{
				var soundData:Object = appData.soundList.getItemAt(i);
				if (soundData.id == tempId)
				{
					appData.currentSound = tempId;
					_sound = new Sound(new URLRequest(soundData.fullfilename));
					break;
				}
			}
			dispatchEvent(new Event("soundChanged"));
		}
		
		public function prevPlay():void
		{
			var playEvent:PlayEvent = new PlayEvent(PlayEvent.PLAY);
			playEvent.id = ApplicationData.getInstance().currentSound - 1;
			dispatcher.dispatchEvent(playEvent);
		}
		
		public function nextPlay():void
		{
			var playEvent:PlayEvent = new PlayEvent(PlayEvent.PLAY);
			playEvent.id = ApplicationData.getInstance().currentSound + 1;
			dispatcher.dispatchEvent(playEvent);
		}
	}
}
