package com.mudchobo.mudchoboplayer.services
{
	import com.mudchobo.mudchoboplayer.data.ApplicationData;
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	import mx.collections.ArrayCollection;
	
	public class PlaylistService extends EventDispatcher
	{
		private var _playlist:ArrayCollection;
		
		[Bindable(event="playlistChanged")]
		public function get playlist():ArrayCollection 
		{
			return _playlist;
		}

		public function addPlaylist(sounds:Array):void
		{
			var appData:ApplicationData = ApplicationData.getInstance();
			for (var i:Number = 0; i < sounds.length; i++)
			{
				var soundData:Object = new Object();
				soundData.id = appData.soundList.length + 1;
				soundData.fullfilename = sounds[i].nativePath;
				soundData.filename = sounds[i].name;
				soundData.time = sounds[i].size;
				
				appData.soundList.addItem(soundData);
			}
			_playlist = appData.soundList;
			dispatchEvent(new Event("playlistChanged"));
		}
		
		public function removePlaylist(selectedId:Number):void
		{
			var i:Number;
			var soundData:Object;
			var appData:ApplicationData = ApplicationData.getInstance();
			
			for (i = 0; i < appData.soundList.length; i++)
			{
				soundData = appData.soundList.getItemAt(i);
				if (soundData.id == selectedId)
				{
					appData.soundList.removeItemAt(i);
					break;
				}
			}
			
			for (i = 0; i < appData.soundList.length; i++)
			{
				soundData = appData.soundList.getItemAt(i);
				soundData.id = i + 1;
				appData.soundList.setItemAt(soundData, i);
			}
			_playlist = appData.soundList;
			dispatchEvent(new Event("playlistChanged"));
		}
		
		public function initPlaylist():void
		{
			var appData:ApplicationData = ApplicationData.getInstance();
			appData.soundList = new ArrayCollection();
			_playlist = appData.soundList;
			dispatchEvent(new Event("playlistChanged"));
		}
	}
}
