// ActionScript file
import com.mudchobo.mudchoboplayer.data.ApplicationData;
import com.mudchobo.mudchoboplayer.events.NavigationEvent;
import com.mudchobo.mudchoboplayer.events.OverviewEvent;
import com.mudchobo.mudchoboplayer.events.PlayEvent;

import flash.events.Event;
import flash.events.MouseEvent;
import flash.media.SoundChannel;

public var sound:Sound;
private var channel:SoundChannel;
private var pausePosition:Number = -1;

// 컴포넌트 생성 시
private function creationCompleteHandler():void
{
	this.addEventListener(Event.ENTER_FRAME, onEnterFrame);	
}

// 프레임 이벤트
private function onEnterFrame(event:Event):void
{
	var overviewEvent:OverviewEvent = new OverviewEvent(OverviewEvent.FRAME);
	overviewEvent.sound = this.sound;
	overviewEvent.channel = this.channel;
	this.dispatchEvent(overviewEvent);
}

// OVERVIEW버튼 클릭 시
private function clickOverview(event:MouseEvent):void
{
	this.dispatchEvent(new NavigationEvent(NavigationEvent.OVERVIEW));
}

// PLAYLIST버튼 클릭 시
private function clickPlaylist(event:MouseEvent):void
{
	this.dispatchEvent(new NavigationEvent(NavigationEvent.PLAYLIST));
}

// WORDS버튼 클릭 시
private function clickWords(event:MouseEvent):void
{
	this.dispatchEvent(new NavigationEvent(NavigationEvent.WORDS));
}

// OPTION버튼 클릭 시
private function clickOption(event:MouseEvent):void
{
	this.dispatchEvent(new NavigationEvent(NavigationEvent.OPTION));
}

// PLAY버튼 클릭 시
private function clickPlay(event:MouseEvent):void
{
	if (!btnPlay.selected)
	{
		pausePosition = channel.position;
		channel.stop();
	}
	else if (pausePosition != -1)
	{
		channel = sound.play(pausePosition);
	}
	else
	{
		var playEvent:PlayEvent = new PlayEvent(PlayEvent.PLAY);
		playEvent.id = 1;
		this.dispatchEvent(playEvent);
	}
}

// STOP버튼 클릭 시
private function clickStop(event:MouseEvent):void
{
	if (channel != null)
	{
		channel.stop();
		pausePosition = -1;
		btnPlay.selected = false;
	}
}

// PREV버튼 클릭 시
private function clickPrev(event:MouseEvent):void
{
	this.dispatchEvent(new PlayEvent(PlayEvent.PREV));
}

// NEXT버튼 클릭 시
private function clickNext(event:MouseEvent):void
{
	this.dispatchEvent(new PlayEvent(PlayEvent.NEXT));
}

// Play이벤트 발생 후 리스너 메소드
private function listenPlayEventPlay():void
{
	if (sound == null)
	{
		btnPlay.selected = false;
		return;
	}
	
	if (channel != null)
	{
		channel.stop();
	}
	pausePosition = 0;
	sound.addEventListener(Event.COMPLETE, onSoundLoaded);
	btnPlay.selected = true;
}

// Sound가 로딩이 완료 되었을 때 
private function onSoundLoaded(event:Event):void
{
	channel = sound.play(pausePosition);
	channel.addEventListener(Event.SOUND_COMPLETE, onSoundCompleteHandler);
}

// Sound재생이 완료 되었을 때
private function onSoundCompleteHandler(event:Event):void
{
	var playEvent:PlayEvent = new PlayEvent(PlayEvent.PLAY);
	playEvent.id = ApplicationData.getInstance().currentSound + 1;
	this.dispatchEvent(playEvent);
}
